import greenfoot.*;

/**
 * The thing the jumper jumps on.
 * <p>
 * If you use this class, please put my name in the credits (if you
 * have so) and put my name in the documentation:
 * 
 * @author Sven van Nigtevecht
 * @version 1.1
 */
public class Platform extends Actor
{
    /**
     * Create a new platform.
     */
    public Platform()
    {
        // create an image:
        GreenfootImage img = new GreenfootImage(50,10);
        img.setColor(java.awt.Color.GREEN);
        img.fill();
        setImage(img);
        // in the original game, the image of the platforms
        // was not created in code, it was loaded from a file.
    }
    
    /**
     * The setLocation method is overwritten.
     * Explanations inside method.
     */
    public void setLocation(int x, int y)
    {
        super.setLocation(x,y); // really set the location (the original behaviour)
        
        // Extra behaviour:
        // If we arrive at the bottom, reset the location at the top.
        if(getY() == getWorld().getHeight() -1) {
            // '-getImage().getWidth()' is because we want to be fully visible
            int limit = (getWorld().getWidth()) -getImage().getWidth();
            // '+getImage().getWidth()' is because we want to be fuly visible (again!)
            int randomX = Greenfoot.getRandomNumber(limit) +getImage().getWidth() /2;
            setLocation(randomX, 0);
        }
        
        // We don't do the extra behaviour in act, because we only
        // want to check we're at the bottom when our location changes,
        // and setLocation is when that happens.
    }
}